using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Diagnostics;
using System.IO;
using System.Threading;

public class DynamicManifestHandler : IHttpHandler
{
   #region IHttpHandler Members

   public bool IsReusable
   {
      get { return true; }
   }

   public void ProcessRequest(HttpContext context)
   {
      string requestUrl = context.Request.Url.ToString();
      string localPath = context.Request.Url.LocalPath;
      string resourcePath =
         context.Server.MapPath(localPath);
      string providerUrl = context.Request.Url.AbsoluteUri + "?username=Joe&password=CORocks";
      string certPath = Path.Combine(Path.GetDirectoryName(resourcePath), "cert.pfx");
      string tempCertPath = context.Server.MapPath("~/temp.application");
      // Output request URLs for diagnostic purposes
      Debug.WriteLine(requestUrl);
      // If it is a deployment manifest
      if (Path.GetExtension(requestUrl).Contains(".application"))
      {
         ManifestHelper.ModifyDeploymentProviderAndSign(resourcePath,tempCertPath, providerUrl,certPath,null);
         // Write generated file into response stream
         context.Response.WriteFile(tempCertPath);
         // Set the appropriate contentType header for a deployment manifest
         context.Response.ContentType = "application/x-ms-application";
      }
   }

   #endregion
}
