using Microsoft.Build.Tasks.Deployment.ManifestUtilities;
using System.IO;
using System.Security.Cryptography.X509Certificates;

public static class ManifestHelper
{
   public static string GetManifestVersion(string path)
   {
      Manifest fest = ManifestReader.ReadManifest(path, false);
      return fest.AssemblyIdentity.Version;
   }

   public static void ModifyDeploymentProviderAndSign(string manifestPathIn, string manifestPathOut, string providerUrl, string certPath, string certFilePassword)
   {
      DeployManifest fest = ManifestReader.ReadManifest(manifestPathIn, false) as DeployManifest;
      fest.DeploymentUrl = providerUrl;
      ManifestWriter.WriteManifest(fest, manifestPathOut);
      X509Certificate2 cert = new X509Certificate2(certPath, certFilePassword);
      SecurityUtilities.SignFile(cert, null, manifestPathOut);
   }
}
