using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

/// <summary>
/// Summary description for AuthorizationModule
/// </summary>
public class AuthorizationModule : IHttpModule
{
	public AuthorizationModule()
	{
		//
		// TODO: Add constructor logic here
		//
	}

   #region IHttpModule Members

   public void Dispose()
   {
      throw new Exception("The method or operation is not implemented.");
   }

   public void Init(HttpApplication context)
   {
      context.AuthorizeRequest += OnAuthorizeRequest;
   }

   void OnAuthorizeRequest(object sender, EventArgs e)
   {
            // Gather context information
      HttpRequest request = HttpContext.Current.Request;
      string user = request.LogonUserIdentity.Name;
      string resource = request.Url.ToString();
      string localPath = request.Url.LocalPath;
      string resourcePath = 
         HttpContext.Current.Server.MapPath(localPath);
      string fileExtension = Path.GetExtension(resource);
      // Log deployment manifest requests
      if (fileExtension == ".application")
      {
         // Get version
         string version =
            ManifestHelper.GetManifestVersion(resourcePath);
         // Lookup access rights
         if (!GrantAccess(user, version))
         {
            HttpContext.Current.Response.StatusCode = 401;
         }

      }
   }

   private bool GrantAccess(string user, string version)
   {
      return true;
   }

   #endregion
}
